<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2021 xt:Commerce GmbH All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # https://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Maximilianstrasse 9, 6020 Innsbruck
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */
  
defined('_VALID_CALL') or die('Direct Access is not allowed.');

global $db, $brotkrumen, $info, $language, $page, $xtLink;

if (isset($xtPlugin->active_modules['xt_blog']) && strpos($page->loaded_page, 'plugins/xt_blog/pages/xt_blog.php') !== false){

    include_once _SRV_WEBROOT.'plugins/xt_blog/classes/class.xt_blog_helper.php';
    include_once _SRV_WEBROOT.'plugins/xt_blog/classes/class.xt_blog_messages.php';



    $blog_helper = new xt_blog_helper();
    $BlogCat= (int)$blog_helper->getReqValue('bc', 0);
    $blog_data = $blog_helper->getBlogCategory($BlogCat);
    $current_page =  (int)$blog_helper->getReqValue('next_page');
    $blog_header = array();
    $blog_header['title'] = $blog_data['blog_categorie_name'] ?: PLUGIN_BLOG_TITLE;
    $blog_header['author'] = $blog_data['author'];
    $blog_header['description'] = $blog_data['blog_category_description'];
    $blog_header['link_list'] = $xtLink->_link(array('page'=>XT_BLOG_PAGE, 'params' => 'next_page='.$current_page));
    $blog_header['show_comments'] = true;
    $blog_header['show_login_link'] = false;
    $blog_header['comment_form'] = false;
    $blog_header['feed_actual_page'] = $current_page;
    $lnk = $xtLink->_link(array('page'=>XT_BLOG_URL, 'xt_blog_main' => true));
    if (is_object($brotkrumen)) $brotkrumen->_addItem($lnk,TEXT_XT_BLOG);

    $blog_helper->getBreadCrumbNavigation_blog();
    $blog_helper->cron_action();

	switch ($page->page_action) {	
    
        case 'feed_rss2' :

                            $BlogDeep = (int)$blog_helper->getReqValue('bd', 99);

                            // blog messages
                            $message_object = new xt_blog_messages();
                            $blog_messages = $message_object->get_messages($BlogCat, $BlogDeep);
      
                            $blog_header['link'] = $xtLink->getCurrentUrl();
                            $blog_header['feed_count'] = $blog_messages['count'];        
                            $blog_header['feed_pages'] = $blog_messages['pages'];        
                            $blog_header['feed_total'] = $blog_messages['total'];   
                            $blog_header['feed_actual_page'] = $blog_messages['actual_page'];      
                            $blog_header['feed_last_page'] = $blog_messages['last_pagel'];      
                                 
                            $web = $blog_helper->gen_feed($blog_messages['data'], $blog_header, 'feed_rss2.html');
                            header("Content-type: application/rss+xml; charset: utf-8");
                            echo $web;
                            $display_output = false;                    
                            break;    
                          
        case 'feed_atom' :
                            $BlogCat= (int)$blog_helper->getReqValue('bc', 0);
                            $BlogDeep = (int)$blog_helper->getReqValue('bd', 99);
                            
                            // blog messages
                            $message_object = new xt_blog_messages();
                            $blog_messages = $message_object->get_messages($BlogCat, $BlogDeep);
                            
                            $blog_header['link'] = $xtLink->getCurrentUrl();
                            $blog_header['feed_id'] = md5(date('Y-m-d H:i:s'));
                            $blog_header['lastbuilddate'] = date("c"); 
                            $blog_header['feed_count'] = $blog_messages['count'];        
                            $blog_header['feed_pages'] = $blog_messages['pages'];        
                            $blog_header['feed_total'] = $blog_messages['total'];  
                            $blog_header['feed_actual_page'] = $blog_messages['actual_page'];      
                            $blog_header['feed_last_page'] = $blog_messages['last_pagel'];      
                                  
                            
                            $web = $blog_helper->gen_feed($blog_messages['data'], $blog_header, 'feed_atom.html');
                            header("Content-type: application/atom+xml; charset: utf-8");
                            echo $web;
                            $display_output = false;                	
		                    break;	
                          
        case 'message':
        				// START accept comment action             
			        	$accept_comment_key = $blog_helper->getReqValue('accept_comment_key');
			        	if(!empty($accept_comment_key))
			        	{
				        	$sql = 'select * from '.TABLE_BLOG_KOMMENTAR.' where accept_key=? limit 1;';
				        	$comment = $db->getRow($sql,array($accept_comment_key));
				        	if(!empty($comment))
				        	{
				        		$db->AutoExecute(TABLE_BLOG_KOMMENTAR, array('public_status'=>'1'), 'UPDATE', "accept_key=".$db->Quote($accept_comment_key));
				        		$info->_addInfo(TEXT_BLOG_COMMENTS_ACCEPT_OK, 'info');
				        	}
				        	else
				        	{
				        		$info->_addInfo(TEXT_BLOG_COMMENTS_ACCEPT_ERROR, 'error');
				        	}
			        	}
			        	// STOP accept comment action
			        	
//                      Umstellunf auf blog_message_id wegen SEO Feld link_id
                        $bmid= (int)$blog_helper->getReqValue('bmid');
                        
                        $message_object = new xt_blog_messages();
                        $message = $message_object->getMessage($bmid);

                        if ($message==false) {
                            $tmp_link  = $xtLink->_link(array('page'=>'404'));
                            $xtLink->_redirect($tmp_link);    
                        }
                        $message_id = $message['blog_message_id'];                         
                        if($blog_header['show_comments'] == true) {
                           $arr_comments = $blog_helper->getComments($message_id);   
                           $message['arr_comments'] = $arr_comments;
                        }
                        $web = $blog_helper->gen_feed(array($message), $blog_header, 'message.html');
                        $page_data = $web;
						
                        break;
        case 'comment_form' :

//                      Umstellunf auf blog_message_id wegen SEO Feld link_id
                        $bmid= (int)$blog_helper->getReqValue('bmid');
                        $sql = 'select * from '.TABLE_BLOG_MESSAGE.' as bm inner join '.TABLE_BLOG_MESSAGE_DESCRIPTION.' as bmd
                        		on bm.blog_message_id=bmd.blog_message_id
                        		where bm.blog_message_id=? 
                        			and bmd.language_code=? limit 1;';
                        $message = $db->getRow($sql,array((int)$bmid,$language->code));
                        $message_id = $message['blog_message_id'];                       
                        $blog_header['show_comments'] = false;
                        if((PLUGIN_BLOG_GUEST_COMMENT == 'true') or (!empty($_SESSION['registered_customer']))){
                            $blog_header['comment_form'] = true;
                        } else {
                           // nicht angemeldet und kein Public_comments = true;
                           $blog_header['comment_form'] = false;
                           $blog_header['show_login_link'] = true;
                           
                           
  //                        check if logged in, if not, set snap and redirect

                            $tmp_link = $xtLink->_link(array('page'=>XT_BLOG_PAGE,'paction' => 'comment_form', 'params'=>'bmid='.(int)$bmid.'&next_page='.$current_page));
                            $brotkrumen->_setSnapshot($tmp_link);

                            $info->_addInfoSession(TEXT_XT_BLOG_COMMENT_ERROR_LOGIN,'error');

                            $tmp_link = $xtLink->_link(array('page'=>'customer','paction'=>'login'));
                            $xtLink->_redirect($tmp_link);
                        }
                        $tpl_data = array();

                    //    $tpl_data['form_link']=$xtLink->_link(array('page'=>XT_BLOG_PAGE,'paction' => 'add_comment', 'params'=>'bmid='.(int)$bmid.'&next_page='.$current_page));
                        $tpl_data = array('products_link' => $blog_helper->get_message_link(array('blog_message_id'=>(int)$bmid)));
                        $web = $blog_helper->gen_feed(array($message), $blog_header, 'add_comment.html',$tpl_data);
                        $page_data = $web;
                        break;
		case 'add_comment' :
						$comment_author_format = $blog_helper->getReqValue('comment_author_format');
						$new_comment_text = $blog_helper->getReqValue('blog_comment_text');
						//Umstellunf auf blog_message_id wegen SEO Feld link_id
						$bmid= (int)$blog_helper->getReqValue('bmid');
                        $sql = 'select * from '.TABLE_BLOG_MESSAGE.' as bm inner join '.TABLE_BLOG_MESSAGE_DESCRIPTION.' as bmd
                        		on bm.blog_message_id=bmd.blog_message_id
                        		where bm.blog_message_id=? 
                        			and bmd.language_code=? limit 1;';
						$message = $db->getRow($sql,array((int)$bmid,$language->code));
						$message_id = $message['blog_message_id'];
						
						if(trim($new_comment_text)==''){
							$info->_addInfo(TEXT_BLOG_COMMENTAR_NOT_ADDED, 'error');

	                        $blog_header['show_comments'] = false;
	                        if((PLUGIN_BLOG_GUEST_COMMENT == 'true') or (!empty($_SESSION['registered_customer']))){
	                            $blog_header['comment_form'] = true;
	                        } else {
	                           // nicht angemeldet und kein Public_comments = true;
	                           $blog_header['comment_form'] = false;
	                           $blog_header['show_login_link'] = true;
	                          
	  							// check if logged in, if not, set snap and redirect
	
	                            $tmp_link = $xtLink->_link(array('page'=>XT_BLOG_PAGE,'paction' => 'comment_form', 'seo_url'=>$language->code.'/'.XT_BLOG_URL.'/comment_form', 'params'=>'bmid='.(int)$bmid.'&next_page='.$current_page));
	                            $brotkrumen->_setSnapshot($tmp_link);
	
	                            $info->_addInfoSession(TEXT_XT_BLOG_COMMENT_ERROR_LOGIN,'error');
	
	                            $tmp_link = $xtLink->_link(array('page'=>'customer','paction'=>'login'));
	                            $xtLink->_redirect($tmp_link);
	                        }
	                        $web = $blog_helper->gen_feed(array($message), $blog_header, 'add_comment.html');
	                        $page_data = $web;
							break;
						}
                        
						$new_comment_username = $blog_helper->gen_comment_author_name($comment_author_format);
						
                        $blog_helper->addComment($message_id, $new_comment_username, $new_comment_text);
                        $info->_addInfo(TEXT_BLOG_COMMENTAR_ADDED, 'success'); 

/*
                        if($blog_header['show_comments'] == true) {
                           $arr_comments = $blog_helper->getComments($message_id);   
                           $message['arr_comments'] = $arr_comments;
                        }
                        $web = $blog_helper->gen_feed(array($message), $blog_header, 'message.html');
                        $page_data = $web;
*/						
						$tpl = 'comment_added.html';
						$tpl_data = array(
							'blog_title'    => $message['title'],
							'message'       => $info->info_content,
							'blog_link'     => $blog_helper->get_message_link($message)
						);
						
						$template = new Template();
						$template->getTemplatePath($tpl, 'xt_blog', '', 'plugin');
						$page_data = $template->getTemplate('smarty', '/'.$tpl, $tpl_data);
                        break;
        
		default : 
						
                        $BlogCat= (int)$blog_helper->getReqValue('bc', 0);
                        $BlogDeep = (int)$blog_helper->getReqValue('bd', 99);
                        $BlogMax = (int)$blog_helper->getReqValue('bm', PLUGIN_BLOG_PAGE_MAX);
                        
                        if(!empty($params))
                        {
                            if($params['cat'] != '' ) $BlogCat= (int)$params['cat'];
                            if($params['deep'] != '' ) $BlogDeep = (int)$params['deep'];
                            if($params['max'] != '' ) $BlogMax = (int)$params['max'];
                        }

                       $message_object = new xt_blog_messages();
					   
                       $blog_messages = $message_object->get_messages($BlogCat, $BlogDeep, $BlogMax);
  
                        if ($blog_messages['total']==0 && is_object($info)) {
                           $info->_addInfo(TEXT_BLOG_CATEGORIES_NO_MESSAGES,'info'); 
                        }
                        $blog_header['feed_count'] = isset($params['max']) ? $BlogMax : $blog_messages['count'];
                        $blog_header['feed_pages'] = isset($params['max']) ? 1 : $blog_messages['pages'];
                        $blog_header['feed_total'] = isset($params['max']) ? $BlogMax : $blog_messages['total'];
                        $blog_header['feed_actual_page'] = isset($params['max']) ? 0 : $blog_messages['actual_page'];
                        $blog_header['feed_last_page'] = $blog_messages['last_page'];
                        $rss_feeds = array();
                        
                        $xtBlogLink = XT_BLOG_URL;
                        
                        if (_SYSTEM_SEO_URL_LANG_BASED == "true") {
                        	$xtBlogLink = $language->code . "/" . $xtBlogLink;
                        }
                        $link = $xtLink->_link(array('page'=> XT_BLOG_PAGE,'paction'=>'feed_rss2','seo_url'=>$xtBlogLink));
                        $link = str_replace('.' . _SYSTEM_SEO_FILE_TYPE, '', $link);
                        $rss_feeds[] = array('title' => TEXT_XT_BLOG_RSS2_ABONNIEREN, 'link' => $link);
                        $link = $xtLink->_link(array('page'=> XT_BLOG_PAGE,'paction'=>'feed_atom','seo_url'=>$xtBlogLink));
                        $link = str_replace('.' . _SYSTEM_SEO_FILE_TYPE, '', $link);
                        $rss_feeds[] = array('title' => TEXT_XT_BLOG_ATOM_ABONNIEREN, 'link' => $link);
                        $blog_header['rss_feeds']=$rss_feeds; 
    
                        $web = $blog_helper->gen_feed($blog_messages['data'], $blog_header, 'feed_web.html');
                        $page_data = $web;
                        
        
						break;
		
	}
	
}
